function string.split(t, b)
	local cmd = {}
	local match = "[^%s]+"
	if b then
		match = "%w+"
	end
	if type(b) == "string" then match = "[^"..b.."]+" end
	if not t then return cmd end
	for word in string.gmatch(t, match) do
		table.insert(cmd, word)
	end
	return cmd
end 

function table.max(t)
	local max,entry = 0,1
	for i=1,#t do
		if t[i] >=  max then max = t[i]; entry = i end
	end
	return max,entry
end


function permute(tab, n, count)
 math.randomseed(os.time())
 math.random()
  n = n or #tab
  for i = 1, count or n do
    local j = math.random(i, n)
    tab[i], tab[j] = tab[j], tab[i]
  end
  return tab
end

function array(v,n)
	arr = {}
	for i=1,n do arr[i] = v end
	return arr
end


function hudtxt2(id,txtid,txt,x,y,align)
	parse("hudtxt2 "..id.." "..txtid..' "'..txt..'" '..x.." "..y.." "..align)
end

function load_maps()	
	local f = io.open("sys/mapcycle.cfg")
	if f == nil then
		print("sys/mapcycle.cfg file not found!")
		return
	end
	local maps = {}	
	while true do
		local line = f:read("*line")
		if line == nil then break end
		if line:sub(1,2) ~= "//" and line ~= "" then
			--cmd = line:split(" ")
			local mapname,gamemode
			if line:sub(-1) == "}" then
				mapname,gamemode  = line:match("(.*) { sv_gamemode (.*); }")
			else
				mapname,gamemode = line,0
			end
			gamemode = tonumber(gamemode) or 0
			if gamemode > 4 then gamemode =0 end
			table.insert(maps,{map = mapname,gm = gamemode})
		end
	end		
	return maps
end

timer = {}
function timer:new(f,max_seconds)
	return setmetatable({seconds = 0, func = f,max_seconds = max_seconds},{__index = timer})
end
function timer:get_time()	
	return os.date("%M:%S",self.seconds)
end

function timer:time_left()
	return os.date("%M:%S",self.max_seconds - self.seconds)
end
function timer:update()
	self.seconds = self.seconds + 1
	
	if self.seconds >= self.max_seconds then
		mapvote[self.func]()		
	end
end