dofile("sys/lua/auxilary.lua")
mapvote = {}
maps = load_maps()
votes = array(0,#maps) 

mapvote.roundlength = 20 -- 20 minutes the length of a round
mapvote.votelength = 0.5 -- 30 seconds, the time to be able to vote
addhook("say","mapvote.say")
addhook("endround","mapvote.endround")
addhook("second","mapvote.second")
addhook("menu","mapvote.menu")

t1 = timer:new("startvote",math.floor((mapvote.roundlength - mapvote.votelength) * 60))

function mapvote.second()
	if t1 ~= nil then
		t1:update()
	end
	
	if vote_period then
		for i=1,#maps do
			local sgm = mapvote.gamemodes[maps[i].gm + 1]
			local mapname = maps[i].map
			
			
			local p = player(0,"table")
			local p_length = #p
			local t = i..". "..mapname.."       "..sgm.." ["..votes[i].."/"..p_length.."]"
			for _i_,_v_ in ipairs(p) do
				hudtxt2(_i_,i,t,10,200+15*i,0)
			end
		end
		
	end
end

function mapvote.say(id, txt)
	if txt:match("!timeleft") then
		if t1 ~= nil then
			msg2(id,"Time left: "..t1:time_left())
		end
	end
end

function mapvote.endround(mode)
	if map_on_startup ~= nil then
		parse("map "..map_on_startup)
		parse("sv_gamemode "..gamemode_on_startup)
	end
end

mapvote.gamemodes = {"standard","dm","team dm","const.","zombies"}
vote_period = false

function mapvote.startvote()
	t1 = timer:new("endvote",mapvote.votelength * 60)	
	msg("200255100Begin your voting!")
	local maps = permute(maps)
	vote_period = true	
	mapvote_menu_string = "Map vote time!@i,"
	
	for i = 1,#maps do
		local sgm = mapvote.gamemodes[maps[i].gm + 1]
		local mapname = maps[i].map
		mapvote_menu_string = mapvote_menu_string..mapname.."|"..sgm..","		
	end
	
	for i,v in ipairs(player(0,"table")) do
		menu(i,mapvote_menu_string)
	end
end

function mapvote.menu(id,menu_name,sel)
	msg2(id,"You voted for "..maps[sel].map)
	if sel >= 0 and sel <= #maps then
		votes[sel] = votes[sel] + 1
	end
end

function mapvote.endvote()
	local max,entry = table.max(votes)
	msg(maps[entry].map.." has won the vote with "..max.." votes!")	
	votes = array(0,#maps)
	t1 = nil
	map_on_startup = maps[entry].map
	gamemode_on_startup = maps[entry].gm
	vote_period = false
	
	
	if game("sv_gamemode") == 0 then
		msg("next map will start at the end of the round!")
	else
		parse("map "..map_on_startup)
		parse("sv_gamemode "..gamemode_on_startup)
	end
end






